/*
 * Ukazka vnorenych trid.
 */

package ija.innerTest;

/**
 * Ukazka vnorenych trid.
 * @author Radek Koci
 */
public class TopLevel1 {
    private String text = "interni promenna tridy TopLevel1";

    public TopLevel1() { System.out.println("Trida TopLevel1"); }
    
    public void test() {
        {
            // Vnorena trida A
            class A {
                public A() { System.out.println("Trida A: " + text); }
            }
            A a = new A();
        }
        Inner in = new Inner();
    }

    public void topM() {
        System.out.println("Metoda topM: " + text);
    }

    /**
     * Vnorena trida Inner
     */
    class Inner {
        public Inner() {
            System.out.println("Trida Inner: " + text);
            topM();
        }
    }

    /**
     * Vnorena staticka trida
     */
    static public class TopLevel2 {
        public TopLevel2() {
            System.out.println("Trida TopLevel2");
            TopLevel1 t = new TopLevel1();
            System.out.println("Trida TopLevel2: " + t.text);
        }
    }
}

